// -------------
// --- usart ---
// -------------

#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>


void USART0_init()
{
	// Set baud rate
	//error 0.80%
	//baudrate 57600
	UBRR0H = 0;
	UBRR0L = 34;
	UCSR0A = (1<<U2X0);
	// Enable receiver and transmitter
		UCSR0B = (1<<RXCIE0)|(1<<RXEN0) | (1<<TXEN0);
	// Set frame format
	UCSR0C = (1<<UCSZ01) | (1<<UCSZ00);
}


void USART0_write(uint8_t data)
{
	// Wait for empty transmit buffer
	while ( !( UCSR0A & (1<<UDRE0)) ) ;
	// Put data into buffer, sends the data
	UDR0 = data;
}

uint8_t USART0_read()
{
// Wait for data to be received
while ( !(UCSR0A & (1<<RXC0)) );
return UDR0;
}


void USART0_puts(unsigned char *txt)
{ 
  while (*txt) USART0_write(*txt++); 
}
